function [cg,ch]=focfun(pz)

global I J N chi w Z y vv t
% t= the tolerance in the Ralph and Wright's RegComp(t) scheme

betap=w;  % preference coefficient for prices
betaz=vv; % preference coefficients for design attributes
zc=y;     % consumer preference targets

% pz size=59 - here is the data structure
p=pz(1:15);     % #15 is the price of the new product (14 competitors) (size=15)
znew=pz(16:19); % the new product attributes (size=4)
muPU=pz(20:34); % Lagrange multipliers for price upper bound (size=15)
muPL=pz(35:49); % Lagrange multipliers for price lower bound (size=15)
muZU=pz(50:53); % Lagrange multipliers for new product z up_bound (size=4)
muZL=pz(54:57); % Lagrange multipliers for new product z lo_bound (size=4)   
muG1=pz(58);    % Lagrange multiplier  for g1 (size=1)
muG2=pz(59);    % Lagrange multiplier  for g2 (size=1)

z=[Z;znew'];
s=gets(p,z);
dcdz=[3,8,4,2]; % cost coefficient
c=z*dcdz'; % calculate cost

% FOC equation - dpi/dp
dpidp=zeros(J,1); % including new product price (#J=15)
for j=1:J
    for i=1:I
        dpidp(j)=dpidp(j)+s(i,j)*(1-chi*betap(i)*(p(j)-c(j))*(1-s(i,j)));
    end
end

% FOC - dpi/dz for new product only (#J=15)
dpidznew=zeros(N,1);
for n=1:N
    for i=1:I
        dpidznew(n)=dpidznew(n)+s(i,J)*...
        (2*chi*betaz(i)*(znew(n)-zc(i,n))*(1-s(i,J))*(p(J)-c(J))+dcdz(n));
    end
end

% generic drug, price fixed at $1.99
% skip FOC for product H (#8)
% p(15) is new product price
ch=[  dpidp(1:7,1)+muPU(1:7,1)-muPL(1:7,1); % FOC-price 1-7
      p(8)-1.99; % skip dummy p8=$1.99 (fixed price)
      dpidp(9:15)+muPU(9:15)-muPL(9:15);  % FOC-price 9-15 (including new product price here)
      dpidznew(1)+muZU(1)-muZL(1)-muG1+muG2;
      dpidznew(2)+muZU(2)-muZL(2)-muG1+muG2; 
      dpidznew(3)+muZU(3)-muZL(3); 
      dpidznew(4)+muZU(4)-muZL(4); ];  % design attribute lower bounds

mugx= muZL'*(0-znew)+  ...  % Z lower bound ( 0 - znew <= 0 )
      muZU'*(znew-1)+  ...  % Z upper bound ( znew - 1 <= 0 )
      muG1*(0.325-znew(1)-znew(2))+ ...  % design constraint g1
      muG2*(znew(1)+znew(2)-0.500);      % design constraint g2

% This form is RegComp(t) in Ralph and Wright's 2004 paper
% RegComp(t): aggregate complemtary slackness conditions (muPL'*GP)
cg = [0.325-znew(1)-znew(2); 
      znew(1)+znew(2)-0.500;
      -(mugx+muPL'*(0-p)+muPU'*(p-10))-t ];  % the is the RegComp(t) term
