function [cg,ceq]=focfun(pz)

global I J N chi w Z t PL PU

% pz size=47: here is the data structure
p=pz(1:15);     % #15 is the price of the new product (14 competitors) (size=15)
znew=pz(16:19); % the new product attributes (size=4)
muPU=pz(20:33); % Lagrange multipliers for followers' price upper bounds (size=14)
muPL=pz(34:47); % Lagrange multipliers for followers' price lower bounds (size=14)
z=[Z;znew'];

s=gets(p,z);
c=sum(z(:,1)*10*0.3+z(:,2)*10*0.8+z(:,3)*10*0.4+z(:,4)*10*0.2,2);

% FOC equation
dpidp=zeros(J,1);
for j=1:J
    for i=1:I
        dpidp(j)=dpidp(j)+s(i,j)*(1-chi*w(i)*(p(j)-c(j))*(1-s(i,j)));
    end
end
% generic drug, price fixed at $1.99

% This form is RegComp(t) in Ralph and Wright's 2004 paper
% RegComp(t): aggregate complemtary slackness conditions (muPL'*GP)
mugp= [muPL'*(PL-p(1:14));  % lower bound for prices
       muPU'*(p(1:14)-PU)]; % upper bound for prices

ceq=[ dpidp(1:7)+muPU(1:7)-muPL(1:7); % FOC-price 1-7
      p(8)-1.99;  % skip FOC for product H #8 due to fixed price
      dpidp(9:14)+muPU(9:14)-muPL(9:14);  % FOC-price 9-15 (including new product price here)
      ];  % exclude new product (it is leader)

cg=[0.325-znew(1)-znew(2);
    znew(1)+znew(2)-0.500;
    -mugp-t ];
% note: price bounds have been include in fmincon bounds
%       not necessary to add in [cg] again