function fval=profitnpfun(pznew)

% Stackelberg leader can predict follower's reactions
% competitors (followers) do Nash competition under leader's input

global I J Z C pfollower COVGETOL

%disp(pznew');
pnew=pznew(1);   % the new product price
znew=pznew(2:5); % the new product attributes

p_update=zeros(J-1,1);
p_prior=pfollower;
covtolflag=0;
count=1;
options = optimset('Display','off','Algorithm','active-set','TolCon',COVGETOL,'TolX',COVGETOL);
% disp(' A     B     C     D     E     F     G     H     I     J     K     L     M     N');
% disp(sprintf('%-0.3f %-0.3f %-0.3f %-0.3f %-0.3f %-0.3f %-0.3f %-0.3f %-0.3f %-0.3f %-0.3f %-0.3f %-0.3f %-0.3f',...
%      p_prior(1),p_prior(2),p_prior(3),p_prior(4),p_prior(5),p_prior(6),p_prior(7),...
%      p_prior(8),p_prior(9),p_prior(10),p_prior(11),p_prior(12),p_prior(13),p_prior(14)));

% big VI iterative loop (Harker/CDH algorithm)
while(covtolflag < J-1) % converge check for competitors' Nash price equilibrium
    for j=1:J-1 % loop for all competitors' profit maximization on pricing
        if j==8
            p_update(8)=1.99; % generic product H with fixed price $1.99
        else
            [pjsol,nprofitj,exitflag]=fmincon(@profitjfun,C(j)+1,[],[],[],[],C(j),3*C(j),[],options,p_prior,j,pnew,znew);
%            [pjsol,nprofitj,exitflag]=fmincon(@profitjfun,p_prior(j),[],[],[],[],C(j),3*C(j),[],options,p_prior,j,pnew,znew);
            if exitflag < 1
                disp('warning: competitor pricing optimization exitflag < 1');
            end
            p_update(j)=pjsol; % save the solution for product j
        end
    end % end of competitor's price decision loop
    
     % modified covergence criteria - check variation percentages
     % | x_t+1 - x_t | / |x_t| < 0.01%
     % check for x_t is very close to zero (may lead to undefined values)
     %covtol=abs( (p_update(1:J-1) - p_prior(1:J-1)) ./ (p_prior(1:J-1)+ (p_prior(1:J-1) < 1e-10)) );
     
     covtol=abs( (p_update(1:J-1) - p_prior(1:J-1)));
     covtolflag = sum(covtol < COVGETOL*10);
     p_prior=p_update;
     count=count+1;
end  % end of Harker-iteration loop

pfollower=p_update;
p=[p_update; pnew];      % renew new product price
z=[Z; znew'];    % collect all attributes
s=gets(p,z);
demand=sum(s,1)';

cnew=znew(1)*10*0.3+znew(2)*10*0.8+znew(3)*10*0.4+znew(4)*10*0.2;
profit_newproduct=(pnew-cnew)*demand(J); % profit of new product
fval=-1*profit_newproduct;
