function fval=profitnpfun(pznew)

% Stackelberg leader can predict follower's reactions
% competitors (followers) do Nash competition under leader's input

global I J Z C pfollower COVGETOL

pnew=pznew(1);   % the new product price
znew=pznew(2:5); % the new product attributes

pz_update=[pfollower; pnew; znew];
pz_old=pz_update+10;
covtolflag=0;
count=1;
options = optimset('Display','off','Algorithm','active-set','TolCon',COVGETOL,'TolX',COVGETOL);

% big SIO loop
while(covtolflag ~=(J-1)) % coverge on competitors' Nash price equilibrium
    count=count+1;
    for j=1:J-1 % loop for all competitors' profit maximization on pricing
        if j==8
            pz_update(8)=1.99; % generic product H with fixed price $1.99
        else
            [pj,profitj,exitflag]=fmincon(@profitjfun,C(j)+1,[],[],[],[],C(j),3*C(j),[],options,pz_update,j);
            if exitflag < 1
                disp('warning: competitor pricing optimization exitflag < 1');
            end
            pz_update(j)=pj; % save the solution for product j
        end
    end % end of competitor's price decision loop
    covtol=abs(pz_update(1:J-1) - pz_old(1:J-1));
    covtolflag = sum(covtol < COVGETOL*10);
    pz_old=pz_update;
    
end % end of SIO loop
% disp(sprintf('%-0.2f %-0.2f %-0.2f %-0.2f %-0.2f %-0.2f %-0.2f %-0.2f %-0.2f %-0.2f %-0.2f %-0.2f %-0.2f %-0.2f %-0.2f',...
%      pz_update(1),pz_update(2),pz_update(3),pz_update(4),pz_update(5),pz_update(6),pz_update(7),...
%      pz_update(8),pz_update(9),pz_update(10),pz_update(11),pz_update(12),pz_update(13),pz_update(14)));
% disp('SIO converged for competitiors pricing');

pfollower=pz_update(1:J-1);
p=[pfollower; pnew];      % renew new product price
z=[Z; znew'];    % collect all attributes
s=gets(p,z);
demand=sum(s,1)';

cnew=znew(1)*10*0.3+znew(2)*10*0.8+znew(3)*10*0.4+znew(4)*10*0.2;
profitnewproduct=(pnew-cnew).*demand(J); % profit of new product
fval=-1*profitnewproduct;

