clear all
close all
clc
load '../latent_class_data.mat'
M=7;
N=6; % z1-5 and price p
% Polynomial to interpolate part worths for each segment
% fit with 4th order polynomial
% v (#segment,#level,#attribute)
zcf=zeros(M,5,N);
for n=1:N, % attribute index n (z1-z5)
    for m=1:M % market segment index m
        zcf(m,:,n)= polyfit(zps(n,:),v(m,:,n),4);
    end
end

%%%% plot poly
figure;
x=0:0.02:1;
for n=1:6
    for m=1:M
        vv(m,:,n)=polyval(zcf(m,:,n),x);
    end
    subplot(3,2,n);
    plot(x,vv(1,:,n),x,vv(2,:,n),x,vv(3,:,n),...
         x,vv(4,:,n),x,vv(5,:,n),x,vv(6,:,n),...
         x,vv(7,:,n) );
    legend('1','2','3','4','5','6','7');
end
