function [G,H]=confun(xp)

global y Z c J Q cf t
global LCSegmentSize p_min z_min p_max z_max betaNCLC zcf
M=length(LCSegmentSize); 

% get s
x=xp(1:14);
x1=x(1); x2=x(2); x3 =x(3);  x4=x(4); x5=x(5); x6=x(6); x7=x(7); 
x8=x(8); x9=x(9); x10=x(10); x11=x(11); x12=x(12); x13=x(13); x14=x(14);
y1=y(1); y2=y(2); y3 =y(3);  y4=y(4); y5=y(5); y6=y(6); y7=y(7); 
y8=y(8); y9=y(9); y10=y(10); y11=y(11); y12=y(12); y13=y(13);

znew=getz(x);
pnew=xp(15);    % new product price
pp=xp(16:15+J); % competitors' prices
mu=xp(15+J+1:15+J+18+28+10);
mux=mu(1:46);  % mu1 -mu46 for foc_x
mup=mu(47:56); % mu47-mu56 for foc_p
z=[Z;znew'];
p=[pp;pnew];

% function output
%g1  Dial diameter must be less than base width,
%g2  Dial diameter must be less than base length minus spring and plate,
%g3  Length of short lever has to be less than base length,
%g4  Joint position on the long lever must be shorter than the length,
%g5  Rack shorter than base when pivot is rotated 90 deg,
%g6  Rack length must be sufficient to span between pivot and center of dial,
%g7  Long lever must attach to top of scale (Pythagorean Theorem),
%g8  Long lever must attach to base a minimum distance y13 from centerline,
g=[ x(12)-(x(14)-2*y(1)); ... %g1
    x(12)-(x(13)-2*y(1)-x(7)-y(9));... %g2 (active mu2~=0)
    (x(4)+x(5))-(x(13)-2*y(1));... %g3
    x(5)-x(2);...  % g4
    (x(7)+y(9)+x(11)+x(8))-(x(13)-2*y(1));... %g5
    (x(13)-2*y(1))-(0.5*x(12)+y(7))-x(7)-y(9)-x(10)-x(8); ... %g6 
    (x(1)+x(2))^2 - (x(13)-2*y(1)-x(7))^2 - (0.5*x(14)-y(1))^2;... %g7
    (x(13)-2*y(1)-x(7))^2+y(13)^2-(x(1)+x(2))^2; %g8
    200-znew(1);   % g9 - upper and lower bounds of z1-z5
    znew(1)-400; 
    0.75-znew(2);  % g11
    znew(2)-1.333;
    100-znew(3);   % g13
    znew(3)-140;   % g14: active mu14~=0
    0.063-znew(4); % g15 
    znew(4)-0.1875;
    0.75-znew(5);  % g17
    znew(5)-1.75; % end of z1-z5
    0.125-x1; % g19
    x1-36;
    0.125-x2; % g21
    x2-36;   
    0.125-x3; % g23
    x3-24; 
    0.125-x4; % g25
    x4-24;
    0.125-x5; % g27
    x5-36;
    1-x6;     % g29
    x6-200;
    0.5-x7;   % g31 (active, mu31~=0)
    x7-12;
    1-x8;     % g33
    x8-36;
    0.25-x9;  % g35
    x9-24;
    0.5-x10;  % g37
    x10-1.9;
    0.5-x11;  % g39
    x11-1.9;
    9-x12;    % g41
    x12-13;
    9-x13;    % g43
    x13-13;
    9-x14;    % g45
    x14-13;]; % g46   

% bounds for prices
gp= [10-p;  %g47-g51
     p-30;];%g52-g56 

dzdx=zeros(5,14);
% dz1/dx
dzdx(1,1)=4*pi*x6*x9*x10*(x3+x4)/x11/(x1*(x3+x4)+x3*(x1+x5))-4*pi*x6*x9*x10*(x1+x2)*(x3+x4)/x11/(x1*(x3+x4)+x3*(x1+x5))^2*(2*x3+x4);
dzdx(1,2)=4*pi*x6*x9*x10*(x3+x4)/x11/(x1*(x3+x4)+x3*(x1+x5));
dzdx(1,3)=4*pi*x6*x9*x10*(x1+x2)/x11/(x1*(x3+x4)+x3*(x1+x5))-4*pi*x6*x9*x10*(x1+x2)*(x3+x4)/x11/(x1*(x3+x4)+x3*(x1+x5))^2*(2*x1+x5);
dzdx(1,4)=4*pi*x6*x9*x10*(x1+x2)/x11/(x1*(x3+x4)+x3*(x1+x5))-4*pi*x6*x9*x10*(x1+x2)*(x3+x4)/x11/(x1*(x3+x4)+x3*(x1+x5))^2*x1;
dzdx(1,5)=-4*pi*x6*x9*x10*(x1+x2)*(x3+x4)/x11/(x1*(x3+x4)+x3*(x1+x5))^2*x3;
dzdx(1,6)=4*pi*x9*x10*(x1+x2)*(x3+x4)/x11/(x1*(x3+x4)+x3*(x1+x5));
%dzdx(1,7)=0;
%dzdx(1,8)=0;
dzdx(1,9)=4*pi*x6*x10*(x1+x2)*(x3+x4)/x11/(x1*(x3+x4)+x3*(x1+x5));
dzdx(1,10)=4*pi*x6*x9*(x1+x2)*(x3+x4)/x11/(x1*(x3+x4)+x3*(x1+x5));
dzdx(1,11)=-4*pi*x6*x9*x10*(x1+x2)*(x3+x4)/x11^2/(x1*(x3+x4)+x3*(x1+x5));
%dzdx(1,12)=0;
%dzdx(1,13)=0;
%dzdx(1,14)=0;
% dz2/dx
dzdx(2,13)=1/x14;
dzdx(2,14)=-x13/x14^2;
% dz3/dx
dzdx(3,13)=x14;
dzdx(3,14)=x13;
% dz4/dx
dzdx(4,1)=-1/4*x12/x6/x9/x10/(x1+x2)^2/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))+1/4*x12/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(2*x3+x4);
dzdx(4,2)=-1/4*x12/x6/x9/x10/(x1+x2)^2/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5));
dzdx(4,3)=-1/4*x12/x6/x9/x10/(x1+x2)/(x3+x4)^2*x11*(x1*(x3+x4)+x3*(x1+x5))+1/4*x12/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(2*x1+x5);
dzdx(4,4)=-1/4*x12/x6/x9/x10/(x1+x2)/(x3+x4)^2*x11*(x1*(x3+x4)+x3*(x1+x5))+1/4*x12/x6/x9/x10/(x1+x2)/(x3+x4)*x11*x1;
dzdx(4,5)= 1/4*x12/x6/x9/x10/(x1+x2)/(x3+x4)*x11*x3;
dzdx(4,6)=-1/4*x12/x6^2/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5));
%dzdx(4,7)=0; 
%dzdx(4,8)=0;
dzdx(4,9)=-1/4*x12/x6/x9^2/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5));
dzdx(4,10)=-1/4*x12/x6/x9/x10^2/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5));
dzdx(4,11)=1/4*x12/x6/x9/x10/(x1+x2)/(x3+x4)*(x1*(x3+x4)+x3*(x1+x5));
dzdx(4,12)=1/4/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5));
%dzdx(4,13)=0;
%dzdx(4,14)=0;
% dz5/dx
dzdx(5,1)=2*(1+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))^2)*(-1/4*y11/x6/x9/x10/(x1+x2)^2/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))+1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(2*x3+x4))*(1/2*x12-y10)/(1+2/y12*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))))-4*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))*(1/2*x12-y10)/(1+2/y12*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))))^2/y12*(1+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))^2)*(-1/4*y11/x6/x9/x10/(x1+x2)^2/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))+1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(2*x3+x4));
dzdx(5,2)=-1/2*(1+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))^2)*y11/x6/x9/x10/(x1+x2)^2/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))*(1/2*x12-y10)/(1+2/y12*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))))+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))*(1/2*x12-y10)/(1+2/y12*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))))^2/y12*(1+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))^2)*y11/x6/x9/x10/(x1+x2)^2/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5));
dzdx(5,3)=2*(1+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))^2)*(-1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)^2*x11*(x1*(x3+x4)+x3*(x1+x5))+1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(2*x1+x5))*(1/2*x12-y10)/(1+2/y12*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))))-4*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))*(1/2*x12-y10)/(1+2/y12*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))))^2/y12*(1+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))^2)*(-1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)^2*x11*(x1*(x3+x4)+x3*(x1+x5))+1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(2*x1+x5));
dzdx(5,4)=2*(1+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))^2)*(-1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)^2*x11*(x1*(x3+x4)+x3*(x1+x5))+1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*x1)*(1/2*x12-y10)/(1+2/y12*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))))-4*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))*(1/2*x12-y10)/(1+2/y12*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))))^2/y12*(1+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))^2)*(-1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)^2*x11*(x1*(x3+x4)+x3*(x1+x5))+1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*x1);
dzdx(5,5)=1/2*(1+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))^2)*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*x3*(1/2*x12-y10)/(1+2/y12*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))))-tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))*(1/2*x12-y10)/(1+2/y12*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))))^2/y12*(1+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))^2)*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*x3;
dzdx(5,6)=-1/2*(1+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))^2)*y11/x6^2/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))*(1/2*x12-y10)/(1+2/y12*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))))+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))*(1/2*x12-y10)/(1+2/y12*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))))^2/y12*(1+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))^2)*y11/x6^2/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5));
%dzdx(5,7)=0;
%dzdx(5,8)=0;
dzdx(5,9)=-1/2*(1+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))^2)*y11/x6/x9^2/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))*(1/2*x12-y10)/(1+2/y12*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))))+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))*(1/2*x12-y10)/(1+2/y12*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))))^2/y12*(1+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))^2)*y11/x6/x9^2/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5));
dzdx(5,10)=-1/2*(1+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))^2)*y11/x6/x9/x10^2/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))*(1/2*x12-y10)/(1+2/y12*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))))+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))*(1/2*x12-y10)/(1+2/y12*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))))^2/y12*(1+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))^2)*y11/x6/x9/x10^2/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5));
dzdx(5,11)=1/2*(1+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))^2)*y11/x6/x9/x10/(x1+x2)/(x3+x4)*(x1*(x3+x4)+x3*(x1+x5))*(1/2*x12-y10)/(1+2/y12*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))))-tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))*(1/2*x12-y10)/(1+2/y12*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))))^2/y12*(1+tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))^2)*y11/x6/x9/x10/(x1+x2)/(x3+x4)*(x1*(x3+x4)+x3*(x1+x5));
dzdx(5,12)=tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5)))/(1+2/y12*tan(1/4*y11/x6/x9/x10/(x1+x2)/(x3+x4)*x11*(x1*(x3+x4)+x3*(x1+x5))));
%dzdx(5,13)=0;
%dzdx(5,14)=0;
% size (8+10+28=46,14)
% x1            x2           x3x4x5x6 x7                    x8 x9 10 11 12  x13                     x14 
dgdx=...  % 1-8 - g1-g8 = (8)
[ 0             0             0 0 0 0  0                     0 0  0  0  1    0                      -1;... %g1/dx
  0             0             0 0 0 0  1                     0 0  0  0  1   -1                      0;...  %g2/dx
  0             0             0 1 1 0  0                     0 0  0  0 -1    0                      0;...  %g3/dx
  0             -1            0 0 1 0  0                     0 0  0  0  0    0                      0;...  %g4/dx
  0             0             0 0 0 0  1                     1 0  0  1  0   -1                      0;...  %g5/dx
  0             0             0 0 0 0 -1                    -1 0 -1  0 -0.5  1                      0;...  %g6/dx
 -2*(x(1)+x(2)) 2*(x(1)+x(2)) 0 0 0 0  2*(x(13)-2*y(1)-x(7)) 0 0  0  0  0   -2*(x(13)-2*y(1)-x(7)) -0.5*(x(14)-2*y(1));... %g7/dx
 -2*(x(1)+x(2)) 2*(x(1)+x(2)) 0 0 0 0 -2*(x(13)-2*y(1)-x(7)) 0 0  0  0  0    2*(x(13)-2*y(1)-x(7))  0;... %g8/dx
% 9-18: z1-z5 * 2 = (10)
 -dzdx(1,:);... % g9/dx   g9:  200-z1 <= 0
  dzdx(1,:);... % g10/dx  g10: z1-400 <= 0
 -dzdx(2,:);... % g11/dx  g11: 0.75-z2 <=0
  dzdx(2,:);... % g12/dx  g12: z2-1.333 <=0
 -dzdx(3,:);... % g13/dx  g13: 100-z3 <=0
  dzdx(3,:);... % g14/dx  g14: z3-140 <=0 (upper bound - active) mu14
 -dzdx(4,:);... % g15/dx  g15: 0.063-z4 <=0 
  dzdx(4,:);... % g16/dx  g16: z4-0.1875 <=0
 -dzdx(5,:);... % g17/dx  g17: 0.75-z5 <=0
  dzdx(5,:);... % g18/dx  g18: z5-1.75 <=0
% 19-46: x1-x14 * 2 = (28)  
 -1  0  0  0  0  0  0  0  0  0  0  0  0  0;... % g19/dx  g19: 0.125-x1 <=0
  1  0  0  0  0  0  0  0  0  0  0  0  0  0;... % g20/dx  g20: x1-36 <= 0
  0 -1  0  0  0  0  0  0  0  0  0  0  0  0;... % g21/dx  g21: 0.125-x2 <=0
  0  1  0  0  0  0  0  0  0  0  0  0  0  0;... % g22/dx  g22: x2-36 <= 0
  0  0 -1  0  0  0  0  0  0  0  0  0  0  0;... % g23/dx  g23: 0.125-x3 <=0
  0  0  1  0  0  0  0  0  0  0  0  0  0  0;... % g24/dx  g24: x3-24 <= 0
  0  0  0 -1  0  0  0  0  0  0  0  0  0  0;... % g25/dx  g25: 0.125-x4 <=0
  0  0  0  1  0  0  0  0  0  0  0  0  0  0;... % g26/dx  g26: x4-24 <= 0
  0  0  0  0 -1  0  0  0  0  0  0  0  0  0;... % g27/dx  g27: 0.125-x5 <=0
  0  0  0  0  1  0  0  0  0  0  0  0  0  0;... % g28/dx  g28: x5-36 <= 0
  0  0  0  0  0 -1  0  0  0  0  0  0  0  0;... % g29/dx  g29: 1-x6 <=0
  0  0  0  0  0  1  0  0  0  0  0  0  0  0;... % g30/dx  g30: x6-200 <= 0
  0  0  0  0  0  0 -1  0  0  0  0  0  0  0;... % g31/dx  g31: 0.5-x7 <=0 (active) mu31
  0  0  0  0  0  0  1  0  0  0  0  0  0  0;... % g32/dx  g32: x7-12 <= 0
  0  0  0  0  0  0  0 -1  0  0  0  0  0  0;... % g33/dx  g33: 1-x8 <=0
  0  0  0  0  0  0  0  1  0  0  0  0  0  0;... % g34/dx  g34: x8-36 <= 0
  0  0  0  0  0  0  0  0 -1  0  0  0  0  0;... % g35/dx  g35: 0.25-x9 <=0
  0  0  0  0  0  0  0  0  1  0  0  0  0  0;... % g36/dx  g36: x9-24 <= 0
  0  0  0  0  0  0  0  0  0 -1  0  0  0  0;... % g37/dx  g37: 0.5-x10 <=0
  0  0  0  0  0  0  0  0  0  1  0  0  0  0;... % g38/dx  g38: x10-1.9 <= 0
  0  0  0  0  0  0  0  0  0  0 -1  0  0  0;... % g39/dx  g39: 0.5-x11 <=0
  0  0  0  0  0  0  0  0  0  0  1  0  0  0;... % g40/dx  g40: x11-1.9 <= 0
  0  0  0  0  0  0  0  0  0  0  0 -1  0  0;... % g41/dx  g41: 9-x12 <=0
  0  0  0  0  0  0  0  0  0  0  0  1  0  0;... % g42/dx  g42: x12-13 <= 0
  0  0  0  0  0  0  0  0  0  0  0  0 -1  0;... % g43/dx  g43: 9-x13 <=0
  0  0  0  0  0  0  0  0  0  0  0  0  1  0;... % g44/dx  g44: x13-13 <= 0
  0  0  0  0  0  0  0  0  0  0  0  0  0 -1;... % g45/dx  g45: 9-x14 <=0
  0  0  0  0  0  0  0  0  0  0  0  0  0  1;];  % g46/dx  g46: x14-13 <= 0


dgpdp=...  % upper and lower bound of prices
[ -1  0  0  0  0; % 10-p1 <=0 % g47
   0 -1  0  0  0; % 10-p2 <=0 % g48
   0  0 -1  0  0; % 10-p3 <=0 % g49
   0  0  0 -1  0; % 10-p4 <=0 % g50
   0  0  0  0 -1; % 10-pnew <=0 % g51
   1  0  0  0  0; % p1-30 <=0 % g52
   0  1  0  0  0; % p2-30 <=0 % g53
   0  0  1  0  0; % p3-30 <=0 % g54
   0  0  0  1  0; % p4-30 <=0 % g55
   0  0  0  0  1;]; % pnew-30 <=0 % g56

[s,sm]=calcMktShare(z,p); % J+1=new, J+2=no-choice option
%zcf(#segment,#coeff-order,#attributes_price)
% price coefficients = zcf(:,:,6)
ps=(p'-p_min)./(p_max-p_min);
dvdp=(4*zcf(:,1,6)*ps.^3+3*zcf(:,2,6)*ps.^2+2*zcf(:,3,6)*ps+zcf(:,4,6)*ones(1,J+1))/(p_max-p_min);
% dvdp(#segment,#product)
% e.g. v=a(p/b)^4; dv/dp=4a(p/b)^3*(1/b)
% foc_p
foc_p= LCSegmentSize' * ( sm(:,1:J+1).*( dvdp(:,1:J+1).*(1-sm(:,1:J+1)).* (ones(M,1)*(p-c)') +1) );

% preparing for numerical differences for dz/dx
xl=x*ones(1,14)-eye(14)*1e-7;
xu=x*ones(1,14)+eye(14)*1e-7;
znewl=getz(xl); % size = (#attribute,#varibales) be ready for dz/dx
znewu=getz(xu); % size = (#attribute,#varibales) be ready for dz/dx
for i=1:14
    sl(:,i)=calcMktShare([Z;znewl(:,i)'],p);
    su(:,i)=calcMktShare([Z;znewu(:,i)'],p);
end
pijl=Q*sl(J+1,:)*(pnew-c)-cf;
piju=Q*su(J+1,:)*(pnew-c)-cf;
foc_x=(piju-pijl)'/2e-7;

% given output
H=[foc_p' - (mup'*dgpdp)';
   foc_x  - (mux'*dgdx)'];

 G=[     g;
        gp;
     -mux'*g - t;
     -mup'*gp - t];    
     
