function [s,sm] = calcMktShare(z,p)

global LCSegmentSize p_min z_min p_max z_max betaNCLC zcf
M=length(LCSegmentSize); % # of market segments
J=length(p); % # of products (will include price_new_product at J)
N=6; % # of attributes (z1-5 and price p)

% zps = mapping z values with upper and lower bounds into normalized 0-1 space
zps= ( [z,p] - ones(J,1)*[z_min;p_min]') ./ ...
      ( ones(J,1)*([z_max;p_max]-[z_min;p_min])' );
%zps(#product,#attribute_price)

% Calculate spline interpolated part worths for each segment
% v is fit with 4th order polynomial
for n=1:N
    %zcf(#segment,#coeff-order,#attributes_&_price)
    %zps(#product,#attribute_&_price)
    %  v(#segment,#product,#attribute_&_price)
    v(:,:,n)=...
    zcf(:,1,n)*zps(:,n)'.^4+zcf(:,2,n)*zps(:,n)'.^3+...
    zcf(:,3,n)*zps(:,n)'.^2+zcf(:,4,n)*zps(:,n)'+zcf(:,5,n)*ones(1,J);
end

% Compile total utility and add no choice option part-worths
% Calculate choice probabilities using logit model
ev = exp([sum(v,3),betaNCLC]);
sumev = sum(ev,2);
sm = ev ./ (sumev * ones(1,J+1)); 
% sm(#segment, #products = J+1 <including no choice option> )

% Market shares for products & no-choice (J+1)
s = (LCSegmentSize' * sm)';
