load FOCSOLS.mat
NumSols=size(sols,1);
TrueCount=0;
clear TrueSols

options = optimset('Display','off','Algorithm','active-set','TolCon',1e-8,'TolX',1e-8);
for i=1:NumSols
    xpsol=sols(i,:);
    znew=getz(xpsol(1:14));
    pnew=xpsol(15);
    pj=xpsol(16:15+J);
    z=[Z;znew];
    pp=[pj';pnew];
    [s,sm]=calcMktShare(z,pp);
    profit0=Q.*s(1:J+1).*(pp-c)-cf;
    failflag=0;
    disp('----');
    for j=1:J
        for m=1:5 % multi-start loop
            p0=5+5*m; % given start point
            [psol,nfval,exitflag2]=fmincon(@jprofit,p0,[],[],[],[],10,30,[],options,j,pp,z);
            if exitflag2>0 && round(-nfval*1e6)>round(profit0(j)*1e6),
                disp(sprintf('Sol#%-2d j=%1d Multi-start#%-2d Nash check failed (%6.3f  > %6.3f) p=%5.2f',i,j,m,-nfval,profit0(j),psol ));
                failflag=failflag+1;
            elseif exitflag2>0 && round(-nfval*1e6)<=round(profit0(j)*1e6),
                disp(sprintf('Sol#%-2d j=%1d Multi-start#%-2d Nash check passed (%6.3f <= %6.3f) p=%5.2f',i,j,m,-nfval,profit0(j),psol ));
            else
                disp(sprintf('Sol#%-2d j=%1d Multi-start#%-2d NLP failed - exitflag=%1d',i,j,m,exitflag2));
                failflag=failflag+1;
            end % end if
        end % end of multi-start loop
    end % end of j loop
    
    if failflag==0
        disp('** Solutions passed Nash check **');
        TrueCount=TrueCount+1;
        TrueSols(TrueCount,:)=pp;

        disp(' #   price  cost  share% profit');
        for j=1:J+1
            disp(sprintf('%3s  %5.2f   %3.1f  %5.2f   %5.2f',brand(j,1:3),pp(j),c,s(j)*100,profit0(j)));
        end
        disp(sprintf('outside good     %5.2f',s(J+2)*100 )); % new=J+1, no-choice=J+2
        % dispaly market share details in segments
        disp('--- market shares in segments (#segments x #product_&_no-choice) ');
        disp(sm)
        % display new product design solution
        disp(sprintf('x1-x7 : %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f',...
              xpsol(1),xpsol(2),xpsol(3),xpsol(4),xpsol(5),xpsol(6),xpsol(7) ));
        disp(sprintf('x8-x14: %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f',...
              xpsol(8),xpsol(9),xpsol(10),xpsol(11),xpsol(12),xpsol(13),xpsol(14) ));
        disp(sprintf('z1-z5 : %7.2f %6.3f %7.2f %6.3f %6.3f',...
              z(J+1,1),z(J+1,2),z(J+1,3),z(J+1,4),z(J+1,5) ));
        
    end % end of j loop
end % end of NumSols loop


if TrueCount == 0
    disp('No truely stable equilibrium solution is found.');
else
    disp(sprintf('\nNumber of solutions found =%-3d',TrueCount));
    sort(TrueSols,1)
end
