function fval=objfunnew(xpnew)

global Q c Z J cf follower
znew=getz(xpnew(1:14));
pnew=xpnew(15);
z=[Z;znew]; % new product is the last one
pp_old=follower.p;
pp_new=pp_old;
TolOverall=1e-6;

% Using Relaxation method - Serial version (SIO)
% Each player optimizes his price decision based on the observation of
%  others right after each optimization
covgflag=0;
options = optimset('Display','off','Algorithm','active-set',...
             'TolCon',TolOverall,'TolX',TolOverall);

while(covgflag < J) % check convergence of all variables
    for j=1:J, % sequential optimization loop for competitors
        [pjsol,nfvalj,exitflag2]=fmincon(@objfunj,pp_old(j),...
               [],[],[],[],10,30,[],options,j,pp_new,pnew,z);
        if exitflag2 > 0,
            pp_new(j)=pjsol; % update 
        else
            disp(sprintf('warning: exitflag2 = %d',exitflag1)); % not update
        end
    end
    covgflag=sum(abs(pp_new - pp_old)<TolOverall*10);
    pp_old=pp_new;
end % end of while loop
follower.p=pp_new;

p=[pp_new,pnew]';
s=calcMktShare(z,p);  % new product is the last one
% note: J+1: newp roduct, J+2: no-choice
profit=Q.*s(1:J+1).*(p-c)-cf;
fval=-1*profit(J+1); % return -profit of new product #J+1